#pragma implementation
#include "Not.h"
#include <cstdio>

Not::Not(const class Formula *formula) : Formula(), myFormula(formula) 
{
  ;
}

Not::Not(const class Not &other) : Formula()
{
  myFormula = other.myFormula->clone();
}

class Not &
Not::operator=(const class Not &rhs)
{
  myFormula = rhs.myFormula->clone();
  return *this;
}

void
Not::print(FILE *file) const 
{
  fputs("! ", file); 
  myFormula->print(file);
}

bool
Not::operator==(const class Formula &other) const
{
  if(other.getType() != fNot)
    return false;
  const class Not &temp=dynamic_cast<const class Not &>(other);
  return (*myFormula==*temp.getOperand());
}
